//+------------------------------------------------------------------+
//|                                    HEIKIN-ASHI ZERO-LAG TEMA.mq4 |
//|                                                          Kalenzo |
//|                                          http://www.fxservice.eu |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "http://www.fxservice.eu"
#property indicator_buffers 1
#property indicator_color1 Magenta
#property indicator_width1 2

double ZLhaTEMA[];

extern int iPeriod = 55;

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorBuffers(1);
SetIndexBuffer(0,ZLhaTEMA);
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
SetIndexLabel(0,"ZERO LAG HATEMA");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   /*
   
   !--------HEIKIN-ASHI ZERO-LAG TEMA--------

    
   haTMA4 is expavg(haTEMA1,emaLen).
   haTMA5 is expavg(haTMA4,emaLen).
   haTMA6 is expavg(haTMA5,emalen).
   haTEMA2 is 3*haTMA4-3*haTMA5+haTMA6.
   Diff3 is haTEMA1 - haTEMA2.
   zeroLAGhaTEMA is haTEMA1 + Diff3.
   !--------end HEIKIN-ASHI ZERO-LAG TEMA--------
   iPeriod
   */
//----
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(int i=0; i<limit; i++)
   {
      double zh1 = iCustom(NULL,0,"haTEMA1",iPeriod,0,i);
      double zh2 = iCustom(NULL,0,"haTEMA2",iPeriod,0,i);
      
      ZLhaTEMA[i] = zh1+(zh1-zh2); 
   }
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+